﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PositionerControlLibrary
{
    public static class ModbusData
    {
        public static string GetModbusAddress(Cmd Cmd)
        {
            if (AddressTable.ContainsKey(Cmd) == false)
            {
                return "";
            }
            return AddressTable[Cmd];
        }
        public enum Cmd : ushort
        {
            STOP,
            JOG_CW,
            JOG_CCW,
            POS_START,
            RTN_ORG,
            SET_ZERO,
            POS_ZERO,
            ESTOP,
            ALM,
            IN_POS,
            POS_OK,
            ORG_OK,
            IN_ZERO,
            CUR_ANGLE_TOTAL,
            CUR_ANGLE_CYCLE,
            TAR_ANGLE_HIGH,
            TAR_ANGLE_LOW,
            TAR_SPEED,
            JOG_SPEED

        }

        static public Dictionary<Cmd, string> AddressTable = new Dictionary<Cmd, string>()
      {
          { Cmd.STOP     , "2048" },
          { Cmd.JOG_CW   , "2049" },
          { Cmd.JOG_CCW  , "2050" },
          { Cmd.POS_START, "2051" },
          { Cmd.RTN_ORG  , "2052" },
          { Cmd.SET_ZERO , "2053" },
          { Cmd.POS_ZERO , "2054" },

          { Cmd.ESTOP , "2058" },
          { Cmd.ALM , "2059" },
          { Cmd.IN_POS , "2060" },
          { Cmd.POS_OK , "2061" },
          { Cmd.ORG_OK , "2062" },
          { Cmd.IN_ZERO , "2063" },

          { Cmd.CUR_ANGLE_TOTAL , "4196" },
          { Cmd.CUR_ANGLE_CYCLE , "4198" },
          { Cmd.TAR_ANGLE_LOW , "4596" },
          { Cmd.TAR_ANGLE_HIGH , "4597" },
          { Cmd.TAR_SPEED , "4598" },
          { Cmd.JOG_SPEED , "4600" },

      };

    }
}
