﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Serialization;


namespace PositionerControlLibrary
{
   
    [XmlRoot("GeneralVariableTable")]
    public class VariableDataTable
    {
        [XmlElement("Version")]
        public string Version { get; set; } = "1.0";


        [XmlArray("Variables")]
        [XmlArrayItem("Variable")]
        public List<VariableData> VariableList { get; set; } = new List<VariableData>();
    }

    public class VariableData
    {
        [XmlAttribute("Name")]
        public string Name { get; set; } = "";

        [XmlAttribute("Address")]
        public uint Address { get; set; } = 0;

        [XmlAttribute("DataType")]
        public VariableTypeDef DataType { get; set; } = VariableTypeDef.BOOL;

    }

    public enum VariableTypeDef : ushort
    {
        BOOL = 1
      , WORD = 2
    }
}
