﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Serialization;

namespace PositionerControlLibrary
{
    public static class VariableDataFactory
    {
        public static string FileName_Xml = "GeneralPageDefine.xml";
        public static string FileName_Txt = "..\\..\\..\\TextFiles\\GeneralPageDefine.txt";
        public static string Target_Folder = "..\\..\\..\\TextFiles";

        private static void CheckTextFolder()
        {
            if (Directory.Exists(Target_Folder)) { return; }

            Directory.CreateDirectory(Target_Folder);
        }

        public static void GetFileData(IPositionerCtrlService CtrlService)
        {
            CheckTextFolder();

            if (File.Exists(FileName_Txt) == false)
            {
                using (var stream = File.Create(FileName_Txt))
                {
                    // Use stream
                }
            }

            File.Copy(FileName_Txt, FileName_Xml, true);

            if (File.Exists(FileName_Xml) == false) { return; }

            XmlSerializer serializer = new XmlSerializer(typeof(VariableDataTable));
            XmlReader reader = XmlReader.Create(FileName_Xml);

            VariableDataTable data = new VariableDataTable();

            try
            {

                if (serializer.CanDeserialize(reader) == false)
                {
                    reader.Close();
                    return;
                }

                data = (VariableDataTable)serializer.Deserialize(reader);
            }
            catch { }

            reader.Close();
            CtrlService.ClearModbusDataList();
            foreach (VariableData p in data.VariableList)
            {
                CtrlService.AddModbusDataList(p);
            }
        }

    }
}
