﻿using PositionerControlLibrary;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PositionerControlToolbar
{
    public partial class GeneralSettingPage : UserControl
    {
        private readonly IPositionerModelService mPositionerModelService = null;
        private readonly IPositionerCtrlService mPositionerCtrlService = null;
        ObservableCollection<VariableTypeDef> enum_data_list = new ObservableCollection<VariableTypeDef>();

        public GeneralSettingPage(IPositionerModelService PositionerModelService)
        {
            InitializeComponent();
            this.mPositionerModelService = PositionerModelService;
            this.mPositionerCtrlService = PositionerModelService.PositionerCtrlService;

            VariableDataFactory.GetFileData(this.mPositionerCtrlService);
            grid_para_table.ItemsSource = mPositionerCtrlService.VariableMockDataList;

            enum_data_list.Add(VariableTypeDef.BOOL);
            enum_data_list.Add(VariableTypeDef.WORD);

            ComboBoxColumn1.ItemsSource = enum_data_list;
        }

        private void btn_read_Click(object sender, RoutedEventArgs e)
        {
            mPositionerModelService.UpdateStatus();
            mPositionerModelService.ReadModbusData();
        }

        private void btn_write_Click(object sender, RoutedEventArgs e)
        {
            mPositionerModelService.WriteModbusData();
        }
    }
}
